/**************************************************************
*                sample.cpp                                   *
*                                                             *
* This file contains examples for the usage of                *
* the OProtocoll, OProcedure and OMethod classes              *
* with the proper macros.                                     *
*                                                             *
* Written by Timm Morten Steinbeck for EDM/2 1994             *
* Internet: Timm_Steinbeck@AC3.maus.de                        *
*                                                             *
**************************************************************/


#include "prot.h"

class FooClass {
public:
  void TestMethod1();
  void TestMethod2();
};

void TestFunction();

int main() {
  PROT_NEW(OProtocoll, "Test.Prt");
  FooClass Foo1, Foo2;
  PROT_TEXT("After creation of Foo1 and Foo2\n");
  PROT_LONG("Address of Foo1", (long)&Foo1);
  PROT_LONG("Address of Foo2", (long)&Foo2);
  Foo1.TestMethod1();
  Foo2.TestMethod2();
  return 0;
}

void FooClass::TestMethod1() {
  PROT_METHOD("FooClass::TestMethod1");
  TestFunction();
}

void FooClass::TestMethod2() {
  PROT_METHOD("FooClass::TestMethod2");
  // Uncomment the following two lines to get a crash.
  //int* P=NULL;
  //*P=0;
}

void TestFunction() {
  PROT_PROCEDURE("TestFunction");
}

